PROGRAM ConCen;
{$R CONCEN}
Uses WinTypes, WinProcs, WObjects, Strings;

CONST
  AppName : PChar = 'CONCEN';
  id_But1  = 121;
  id_won   = 201;
  myTimer  = 1;
  wm_Won   = 1;
  sc_About = 101;
  cm_New   = 101;
  cm_Quit  = 102;
  cm_4x3   = 103;
  cm_4x4   = 104;
  cm_4x5   = 105;
  cm_4x6   = 106;
  cm_5x6   = 107;
  cm_6x6   = 108;
  cm_Help  = 109;
  YahQuit : Boolean = TRUE;
  TheRow : Word = 3;
  TheCol : Word = 4;

TYPE
  TMyApplication = object(TApplication)
    procedure InitMainWindow; virtual;
  END;

  PConcWindow = ^TConcWindow;
  TConcWindow = OBJECT(TWindow)
    States : ARRAY[0..35] OF Word;
    Pics   : ARRAY[0..35] OF Word;
    Seen   : ARRAY[0..35] OF Boolean;
    First, Second, Got, Max, Score : Integer;
    Notified : Boolean;
    CONSTRUCTOR Init(co, ro : Word);
    PROCEDURE SetUpWindow; Virtual;
    DESTRUCTOR Done; Virtual;
    FUNCTION GetClassName : PChar; Virtual;
    PROCEDURE NewGame;
    PROCEDURE NewSize(co, ro : Word);
    PROCEDURE GetWindowClass(var AWndClass: TWndClass); virtual;
    PROCEDURE WMDrawItem(VAR Msg : TMessage); Virtual wm_First + wm_DrawItem;
    PROCEDURE WMTimer(VAR Msg : TMessage); Virtual wm_First + wm_Timer;
    PROCEDURE WMSysCommand(VAR Msg : TMessage); Virtual wm_First + wm_SysCommand;
    PROCEDURE WMWon(VAR Msg : TMessage); Virtual wm_User + wm_Won;
    PROCEDURE CMNew(VAR Msg : TMessage); Virtual cm_First + cm_New;
    PROCEDURE CMQuit(VAR Msg : TMessage); Virtual cm_First + cm_Quit;
    PROCEDURE CMHelp(VAR Msg : TMessage); Virtual cm_First + cm_Help;
    PROCEDURE cm4x3(VAR Msg : TMessage); Virtual cm_First + cm_4x3;
    PROCEDURE cm4x4(VAR Msg : TMessage); Virtual cm_First + cm_4x4;
    PROCEDURE cm4x5(VAR Msg : TMessage); Virtual cm_First + cm_4x5;
    PROCEDURE cm4x6(VAR Msg : TMessage); Virtual cm_First + cm_4x6;
    PROCEDURE cm5x6(VAR Msg : TMessage); Virtual cm_First + cm_5x6;
    PROCEDURE cm6x6(VAR Msg : TMessage); Virtual cm_First + cm_6x6;
  END;

{--------------------------------------------------}
{ TConcWindow's methods }
{--------------------------------------------------}
  PROCEDURE TConcWindow.CMNew(VAR Msg : TMessage);
  BEGIN NewGame; END;

  PROCEDURE TConcWindow.CM4x3(VAR Msg : TMessage); BEGIN NewSize(4, 3); END;
  PROCEDURE TConcWindow.CM4x4(VAR Msg : TMessage); BEGIN NewSize(4, 4); END;
  PROCEDURE TConcWindow.CM4x5(VAR Msg : TMessage); BEGIN NewSize(4, 5); END;
  PROCEDURE TConcWindow.CM4x6(VAR Msg : TMessage); BEGIN NewSize(4, 6); END;
  PROCEDURE TConcWindow.CM5x6(VAR Msg : TMessage); BEGIN NewSize(5, 6); END;
  PROCEDURE TConcWindow.CM6x6(VAR Msg : TMessage); BEGIN NewSize(6, 6); END;

  PROCEDURE TConcWindow.cmHelp(VAR Msg : TMessage);
  VAR ADlg : PDialog;
  BEGIN
    New(ADlg, Init(@Self, 'ConcenHlp'));
    Application^.ExecDialog(ADlg);
  END;

  PROCEDURE TConcWindow.NewSize(co, ro : Word);
  BEGIN
    YahQuit := FALSE;
    TheRow := ro;
    TheCol := co;
    CloseWindow;
  END;

  PROCEDURE TConcWindow.NewGame;
  VAR
    N, X, Y : Word;
    Mix : ARRAY[0..23] OF Word;
  BEGIN
    FillChar(States, SizeOf(States), 0);
    FillChar(Seen, SizeOf(Seen), 0);
    FOR N := 0 to 23 DO Mix[N] := 23-N;
    {Mix up the different tiles to select
     a random set for this game}
    FOR X := 23 DOWNTO 1 DO
      BEGIN
        {swap the item in the Xth slot with any
         item at or below that slot}
        Y := Random(X);
        N       := Mix[X];
        Mix[X] := Mix[Y];
        Mix[Y] := N;
      END;
    FOR N := 0 to pred(Max) DO
      Pics[N] := Succ(Mix[N MOD (Max DIV 2)]);
    {Mix up the tiles being used in this game}
    FOR X := pred(Max) DOWNTO 1 DO
      BEGIN
        {swap the item in the Xth slot with any
         item at or below that slot}
        Y := Random(X);
        N       := Pics[X];
        Pics[X] := Pics[Y];
        Pics[Y] := N;
      END;
    First := -1; Second := -1; Got := 0; Score := 0;
    Notified := FALSE;
    InvalidateRect(hWindow, NIL, FALSE);
  END;

  PROCEDURE TConcWindow.CMQuit(VAR Msg : TMessage);
  BEGIN CloseWindow; END;

  PROCEDURE TConcWindow.wmTimer(VAR Msg : TMessage);
  VAR hw : hWnd;
  BEGIN
    IF Notified THEN Exit;
    {IF two tiles are turned up...}
    IF (First >= 0) AND (Second >= 0) THEN
      BEGIN
        {If they DON'T match...}
        IF Pics[First] <> Pics[Second] THEN
          BEGIN
            States[First] := 0;
            States[Second] := 0;
            hw := GetDlgItem(hWindow, id_But1 + First);
            InvalidateRect(hw, NIL, FALSE);
            hw := GetDlgItem(hWindow, id_But1 + Second);
            InvalidateRect(hw, NIL, FALSE);
          END;
        First := -1;
        Second := -1;
      END;
    IF Got = Max THEN SendMessage(hWindow,wm_User + wm_Won, 0, 0);
  END;

  PROCEDURE TConcWindow.wmSysCommand(VAR Msg : TMessage);
  VAR ADlg : PDialog;
  BEGIN
    IF Msg.wParam = sc_about THEN
      BEGIN
        New(ADlg, Init(@Self, 'ConcenAbt'));
        Application^.ExecDialog(ADlg);
      END;
    DefWndProc(Msg);
  END;

  PROCEDURE TConcWindow.WMWon(VAR Msg : TMessage);
  VAR
    Scores : RECORD
      Exc, Good, Yours : ARRAY[0..4] OF Char;
      Mesg : ARRAY[0..20] OF Char;
    END;
    ADlg : PDialog;
    PS   : PStatic;
  BEGIN
    Notified := TRUE;
    New(ADlg, Init(@Self, 'ConcenWon'));
    WITH Scores DO
      BEGIN
        Str(Max DIV 2, Exc);
        Str(Max, Good);
        Str(Score, Yours);
        FillChar(Mesg, SizeOf(Mesg), 0);
        IF Score = 0 THEN
          StrMove(Mesg, 'ASTOUNDING + LUCKY!', 19)
        ELSE IF Score <= Max DIV 2 THEN
          StrMove(Mesg, 'ASTOUNDING!', 11)
        ELSE IF Score <= Max THEN
          StrMove(Mesg, 'EXCELLENT!', 10)
        ELSE IF Score <= 2*Max THEN
          StrMove(Mesg, 'PRETTY GOOD.', 12)
        ELSE StrMove(Mesg, 'ANOTHER TRY?', 12);
      END;
    New(PS, InitResource(Adlg, id_won, 5));
    New(PS, InitResource(Adlg, id_won + 1, 5));
    New(PS, InitResource(Adlg, id_won + 2, 5));
    New(PS, InitResource(Adlg, id_won + 3, 21));
    WITH ADlg^ DO
      BEGIN
        EnableTransfer;
        TransferBuffer := @Scores;
        TransferData(tf_SetData);
      END;

    Application^.ExecDialog(ADlg);
    NewGame;
  END;

  PROCEDURE TConcWindow.WMDrawItem(VAR Msg : TMessage);
  VAR
    PD    : ^TDrawItemStruct;
    Pict  : hBitMap;
    Bits  : hDC;
    Which : Word;
    pen   : hPen;
  CONST
    BNum : PChar = 'B01';
  BEGIN
    LongInt(PD) := Msg.lParam;
    WITH PD^ DO
      IF CtlType = odt_Button THEN
        BEGIN
          Which := CtlID - id_But1;
          IF States[Which] < 2 THEN
            IF ItemAction = oda_select THEN
              BEGIN
                IF First < 0 THEN
                  BEGIN
                    First := which;
                    States[Which] := States[which] OR $0001;
                    IF Seen[Which] THEN Inc(Score);
                    Seen[Which] := TRUE;
                  END
                ELSE IF (Second < 0) AND (which <> first) THEN
                  BEGIN
                    Second := which;
                    States[Which] := States[which] OR $0001;
                    IF Seen[Which] THEN Inc(Score);
                    Seen[Which] := TRUE;
                    (*!*)
                    IF Pics[First] = Pics[Second] THEN
                      BEGIN
                        States[First] := 2;
                        States[Second] := 2;
                        Inc(Got, 2);
                        First := -1;
                        Second := -1;
                      END;
                    (*!*)
                  END
                ELSE IF (First <> which) AND (Second <> which) THEN
                  MessageBeep(0);
              END;

          CASE PD^.ItemAction OF
            oda_DrawEntire,
            oda_Select :
              BEGIN
                IF States[which] > 0 THEN
                  BEGIN
                    BNum[1] := Char(Ord('0') + (Pics[Which] DIV 10));
                    BNum[2] := Char(Ord('0') + (Pics[Which] MOD 10));
                    Pict := LoadBitMap(hInstance, BNum);
                  END
                ELSE Pict := LoadBitmap(hInstance, 'BUTN');
                Bits := CreateCompatibleDC(hDC);
                SelectObject(Bits, Pict);
                BitBlt(hDC, 1, 1, 64, 40, Bits, 0, 0, SrcCopy);
                DeleteDC(Bits);
                DeleteObject(Pict);
              END;
          END;
          IF ItemAction = oda_Focus THEN
            BEGIN
              IF GetDlgItem(hWindow, CtlID) = GetFocus THEN
               pen := GetStockObject(Black_Pen)
              ELSE pen := GetStockObject(White_Pen);
              SelectObject(hDC, Pen);
              WITH rcItem DO
                BEGIN
                  MoveTo(hDC, Left, Bottom);
                  LineTo(hDC, Left, Top);
                  LineTo(hDC, Right, Top);
                END;
              DeleteObject(pen);
            END;
        END;
  END;

  PROCEDURE TConcWindow.SetUpWindow;
  VAR
    R       : TRect;
    SysMenu : HMenu;
  BEGIN
    TWindow.SetUpWindow;
    {Remove useless system menu items; add "About"}
    SysMenu := GetSystemMenu(hWindow, FALSE);
    RemoveMenu(SysMenu, sc_Maximize, mf_ByCommand);
    RemoveMenu(SysMenu, sc_Size, mf_ByCommand);
    AppendMenu(SysMenu, mf_separator, 0, NIL);
    AppendMenu(SysMenu, mf_String, sc_About, 'About ...');
    SetTimer(hWindow, myTimer, 1000, NIL);
    FocusChildHandle := ChildWithID(id_But1)^.hWindow;
    SetRect(R, 0, 0, TheCol*40 + 2, TheRow*40 + 2);
    AdjustWindowREct(R, Attr.Style, TRUE);
    SetWindowPos(hWindow, 0, 0, 0, R.Right-R.Left,
      R.Bottom-R.Top, swp_NoMove OR swp_NoZOrder);
  END;

  CONSTRUCTOR TConcWindow.Init(co, ro : Word);
  VAR
    N, X, Y : Word;
    Ab      : PButton;
  BEGIN
    TWindow.Init(Nil, AppName);
    Attr.Menu := LoadMenu(hInstance, AppName);
    Attr.Style := Attr.Style AND (NOT ws_SizeBox)
                    AND (NOT ws_MaximizeBox)
                    AND (NOT ws_Visible);
    EnableKbHandler;
    Max := ro * co;
    FOR Y := 0 to pred(ro) DO
      FOR X := 0 to pred(co) DO
        BEGIN
          ab := New(PButton, Init(@Self, id_But1 + co*Y + X, '',
            40*X, 40*Y, 40, 40, FALSE));
          WITH Ab^.Attr DO
            Style := Style AND (NOT bs_PushButton)
                           AND (NOT ws_Group)
                           OR bs_OwnerDraw OR ws_TabStop;
          IF (X+Y=0) THEN
            WITH ab^.Attr DO Style := Style OR ws_Group;
        END;
    Randomize;
    NewGame;
  END;

  DESTRUCTOR TConcWindow.Done;
  BEGIN
    KillTimer(hWindow, myTimer);
    TWindow.Done;
  END;

  FUNCTION TConcWindow.GetClassName;
  BEGIN GetClassName := AppName; END;

  PROCEDURE TConcWindow.GetWindowClass(VAR AWndClass : TWndClass);
  BEGIN
    TWindow.GetWindowClass(AWndClass);
    AWndClass.hIcon := LoadIcon(HInstance, AppName);
  END;

{--------------------------------------------------}
{ TMyApplication's method implementations:         }
{--------------------------------------------------}

PROCEDURE TMyApplication.InitMainWindow;
BEGIN
  YahQuit := TRUE;
  MainWindow := New(PConcWindow, Init(TheCol, TheRow));
END;
{--------------------------------------------------}
{ Main program:                                    }
{--------------------------------------------------}

VAR MyApp: TMyApplication;
BEGIN
  REPEAT
    MyApp.Init(AppName);
    MyApp.Run;
    MyApp.Done;
  UNTIL YahQuit;
END.
